/*
 *  SCREEN, {akii-root}/src/screen.c
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#include <stdlib.h>
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>
#include <errno.h>
#include "screen.h"
#include "terms.h"
#include "variables.h"
#include "main.h"
#include "debug.h"

struct valtozo *akii_usebold;
int usebold;

#ifdef __CYGWIN32__
int nocs = 1;

#else
int nocs = 0;

#endif
int winsize = 10, usewin = 1, wantedwinsize = 10, oldwinsize = 10;

struct inplines *sorok = NULL, *soreleje = NULL, *asor = NULL;
struct inplines *scrollsorok = NULL;
int sorokszam = 0;

int cursor = 1, curcur = -1, gorg = 0;
char curinp[1200] = "";
struct inplines *inps = NULL, *ainp = NULL, *binp = NULL;
int inpnum = 0;

char saveinp[1024];
int savecursor = 0;

char lastsline[300], lastwinsline[300];
struct valtozo *akii_status, *akii_winstatus;
struct valtozo *akii_nick;
struct valtozo *akii_csatorna;
struct valtozo *akii_nocs;

char inp[1024] = "", *inpp = inp;
int inplen = 0;
int botmode = 0;

char *winlines[2000];
char winbase[300] = "/KI \"*\" lista";
char winbase_temp[300];
int topline = 0, lastwinline = 0;

void sigwinch(int);

void initscreen(void)
{
    char temp[50], *t = temp;
    int save_varflag = varflag;

    if (!botmode)
	setownterm();
    sigwinch(0);
    signal(SIGWINCH, sigwinch);
    strcpy(t, "akii.statusz");
    varflag = VFLAG_BELSO;
    akii_status = getvar(&bivarlist, &t, 1, 0);
    t = temp;
    strcpy(t, "akii.winstatusz");
    akii_winstatus = getvar(&bivarlist, &t, 1, 0);
    varflag = save_varflag;
    memset(winlines, 0, sizeof(winlines));
    refresh(1);
    return;
}
void donescreen(void)
{
    struct inplines *p = inps;

    if (!botmode)
	setoriginalterm();
    if (!botmode)
	printf("\033[r\033[%d;1H\033[K", LINES);
    while (p) {
	inps = p;
	free(p->s);
	p = inps->prev;
	free(inps);
    }
    return;
}
void freeinplines(void)
{
    struct inplines *l;

    while (binp) {
	free(binp->s);
	l = binp->next;
	free(binp);
	binp = l;
    }
    binp = inps = ainp = NULL;
    while (soreleje) {
	free(soreleje->s);
	l = soreleje->next;
	free(soreleje);
	soreleje = l;
    }
    soreleje = NULL;
    return;
}
void addsorok(char *s)
{
    struct inplines *l;

    if (sorokszam > 1000) {
	if (asor == soreleje)
	    asor = asor->next;
	free(soreleje->s);
	l = soreleje->next;
	free(soreleje);
	soreleje = l;
	l->prev = NULL;
	sorokszam--;
    }
    sorokszam++;
    l = malloc(sizeof(struct inplines));

    l->s = strdup(s);
    if (sorokszam == 1) {
	sorok = soreleje = l;
	l->next = l->prev = NULL;
	return;
    }
    sorok->next = l;
    l->prev = sorok;
    l->next = NULL;
    sorok = l;
    return;
}
char *chop(char *s)
{
    int i, j = 0, b = 0;
    static char temp[400];

    temp[0] = 0;
    for (i = 0; *s; s++, i++) {
	if (*s == 033)
	    b = 1;
	if (!b)
	    j++;
	temp[i] = *s;
	if (j >= COLS) {
	    if (b) {
		s = temp + i;
		for (; *s != 033; s--) ;
		*s = 0;
	    }
	    break;
	}
	if (*s == 'm')
	    b = 0;
    }
    temp[i] = 0;
    return (temp);
}
int echostr(char *s)
{
    int i, j, f = 0, p = -1, x = 0, b = 0, r = 0, c;
    int s1 = -1, s2;
    static char temp[1024];
    static char temps[1024];
    static char ctemp[100];

    if (botmode && botmode != 100)
	return;
    *ctemp = 0;
    j = strlen(s);
    if (!nocs && !botmode)
	printf("\033[%d;1H", LINES - 2);
    for (i = 0; i < j; i++) {
	if (s[i] == 033) {
	    f = 1;
	    s1 = i;
	    continue;
	}
	if ((s[i] == 'm') && f) {
	    f = 0;
	    s2 = i - s1 + 1;
	    continue;
	}
	if (!f)
	    x++;
	else
	    continue;
	if (s[i] == 32)
	    p = i;
	if (x >= COLS - 1) {
	    if (p == -1) {
		strncpy(temp, s + b, i - b);
		temp[i - b] = 0;
		b = i;
	    }
	    else {
		strncpy(temp, s + b, p - b);
		temp[p - b] = 0;
		b = p;
	    }
	    if (!r) {
		sprintf(temps, "%s%s%s", ctemp, temp, (s1 >= 0) ? "\033[0m" : "");
		*ctemp = 0;
		x = 0;
	    }
	    else {
		sprintf(temps, "%s%s%s", ctemp, temp, (s1 >= 0) ? "\033[0m" : "");
		*ctemp = 0;
		x = 3;
	    }
	    addsorok(temps);
	    if (!nocs && !botmode)
		printf("\r\n%s", temps);
	    if (s1 >= 0) {
		strncpy(ctemp, s + s1, s2);
		ctemp[s2] = 0;
		s1 = -2;
	    }
	    if (p != -1) {
		x += i - p;
	    }
	    p = -1;
	    r++;
	}
    }
    if (b < i) {
	sprintf(temps, "%s%s", ctemp, s + b);
	addsorok(temps);
	if (!nocs && !botmode)
	    printf("\r\n%s\033[0m", temps);
    }
    if (!j) {
	if (!nocs && !botmode)
	    printf("\n");
	addsorok("");
    }
    if (nocs && !botmode) {
	/*printf("\0337"); */
	writesorok(1);
    }
    if (!botmode)
	printf("\033[%d;%dH", LINES, curcur);
    return (0);
}
void winclear(void)
{
    int i;

    for (i = 0; i <= lastwinline; i++) {
	if (winlines[i])
	    free(winlines[i]);
	winlines[i] = NULL;
    }
    topline = lastwinline = 0;
    return;
}
void winechostr(char *s)
{
    int i, j, f = 0, p = -1, x = 0, b = 0, r = 0, c;
    int s1 = -1, s2;
    static char temp[1024];
    static char temps[1024];
    static char ctemp[100];
    int h;

    if (botmode && botmode != 100)
	return;
    if (lastwinline >= 1999)
	return;
    *ctemp = 0;
    j = strlen(s);
/*        if (!botmode) printf("\0337"); */
    for (i = 0; i < j; i++) {
	if (s[i] == 033) {
	    f = 1;
	    s1 = i;
	    continue;
	}
	if ((s[i] == 'm') && f) {
	    f = 0;
	    s2 = i - s1 + 1;
	    continue;
	}
	if (!f)
	    x++;
	else
	    continue;
	if (s[i] == 32)
	    p = i;
	if (x >= COLS) {
	    if (p == -1) {
		strncpy(temp, s + b, i - b);
		temp[i - b] = 0;
		b = i;
	    }
	    else {
		strncpy(temp, s + b, p - b);
		temp[p - b] = 0;
		b = p;
	    }
	    if (!r) {
		sprintf(temps, "%s%s%s", ctemp, temp, (s1 >= 0) ? "\033[0m" : "");
		*ctemp = 0;
		x = 0;
	    }
	    else {
		sprintf(temps, "%s%s%s", ctemp, temp, (s1 >= 0) ? "\033[0m" : "");
		*ctemp = 0;
		x = 3;
	    }
	    winlines[++lastwinline] = strdup(temps);
	    if (lastwinline == 1)
		topline = 1;
	    h = lastwinline - topline;
	    if (!botmode)
		if (h < winsize)
		    printf("\033[%d;1H%s\033[K", h + 1, temps);
	    if (s1 >= 0) {
		strncpy(ctemp, s + s1, s2);
		ctemp[s2] = 0;
		s1 = -2;
	    }
	    if (p != -1) {
		x += i - p;
	    }
	    p = -1;
	    r++;
	}
    }
    if (b < i) {
	sprintf(temps, "%s%s", ctemp, s + b);
	winlines[++lastwinline] = strdup(temps);
	if (lastwinline == 1)
	    topline = 1;
	h = lastwinline - topline;
	if (!botmode)
	    if (h < winsize)
		printf("\033[%d;1H%s\033[0m\033[K", h + 1, temps);
    }
    if (!j) {
	winlines[++lastwinline] = strdup("");
	if (lastwinline == 1)
	    topline = 1;
	h = lastwinline - topline;
	if (!botmode)
	    if (h < winsize)
		printf("\033[%d;1H\033[K", h + 1);
    }
    if (!botmode)
	printf("\033[%d;%dH", LINES, curcur);
    return;
}
void writesorok(int hide)
{
    struct inplines *l = sorok;
    int i, j;
    static szamlalo = 0;

    if (!sorok)
	return;
    if (scrollsorok)
	l = scrollsorok;
    for (i = LINES - 2 - winsize - ((winsize) ? 1 : 0); i > 1; i--) {
	if (l->prev)
	    l = l->prev;
	else
	    break;
    }
    if (hide && !nocs)
	printf("\033[?25l");
    printf("\033[%d;1H", 1 + winsize + ((winsize) ? 1 : 0));
    j = i;
    for (; i > 1; i--)
	printf("\033[K\n");
    printf("%s\033[0m\033[K", chop(l->s));
    l = l->next;
    j++;
    while (l) {
	if (!scrollsorok)
	    printf("\n%s\033[K\033[0m", chop(l->s));
	else
	    printf("\n\033[K%s\033[0m", chop(l->s));
	l = l->next;
	if (++j > LINES - 2 - winsize - ((winsize) ? 1 : 0))
	    break;
    }
    if (hide && !nocs)
	printf("\033[?25h");
    return;
}
void refresh(int all)
{
    int i;
    struct inplines *l = sorok;

    if (botmode)
	return;
    if (all)
	printf("\033[H\033[J\033[%d;%dr", (winsize) ? winsize + 2 : 1, LINES - 2);
    else
	printf("\033[%d;%dr", (winsize) ? winsize + 2 : 1, LINES - 2);
    lastsline[0] = 0;
    lastwinsline[0] = 0;
    curinp[0] = 2;
    curinp[1] = 0;
    writewindow();
    writewindowstatus();
    writesorok(1);
    if (!all)
	return;
    writestatus();
    writeinput();
    return;
}
char *timeinterval(long time)
{
    static char tmp[20];
    int ora, perc;

    time /= 60;
    perc = time % 60;
    ora = time / 60;
    if (ora == 100)
	ora = 0;
    sprintf(tmp, "%03d:%02d", ora, perc);
    return (tmp);
}
int strszlen(char *s)
{
    int i = 0;
    int inszin = 0;

    for (; *s; s++) {
	if (*s == '\033' && !inszin) {
	    inszin = 1;
	    continue;
	}
	if (*s == 'm' && inszin) {
	    inszin = 0;
	    continue;
	}
	if (!inszin)
	    i++;
    }
    return (i);
}
void parsestatus(char *ezt, char *ide, int statusz)
{
    char *p = ezt;
    char *q = ide;
    char *t, *b = NULL;
    int i, j, k, l, ii, kk;
    time_t ido;
    struct valtozo *var;
    int st_fg, st_bg, st_mode;
    int szinekben = 0;

#ifdef AKII_DEBUG
    dbgenter(dbg_parsestatus, ezt);
#endif
    if (statusz)
	if (*p && *(p + 1)) {
	    if (!(*p == '%' && *(p + 1) == '^')) {
		sprintf(q, szin(33, 44, 1));
		szinekben = strlen(szin(33, 44, 1));
		q += szinekben;
		szini = 0;
	    }
	}
    while (*p) {
	if (*p == '%')
	    switch (p[1]) {
		case 'o':
		case 'O':
		    if (!lastwinline || !winsize)
			i = 0;
		    else {
			i = topline / winsize + 1;
			if (!(topline % winsize))
			    i--;
			if (topline % winsize > 1)
			    i++;
		    }
		    sprintf(q, "%d", i, topline, lastwinline);
		    q += strlen(q);
		    q--;
		    p++;
		    break;
		case 'a':
		case 'A':
		    if (!lastwinline || !winsize)
			i = 0;
		    else {
			i = lastwinline / winsize + 1;
			if (!(lastwinline % winsize))
			    i--;
		    }
		    sprintf(q, "%d", i);
		    q += strlen(q);
		    q--;
		    p++;
		    break;
		case 'c':
		case 'C':
		    strcpy(q, akii_csatorna->ertek);
		    q += strlen(akii_csatorna->ertek) - 1;
		    p++;
		    break;
		case 's':
		case 'S':
		    sprintf(q, "%d", lastwinline);
		    q += strlen(q);
		    q--;
		    p++;
		    break;
		case '^':
		    p += 2;
		    /*if (!statusz) break; */
		    st_mode = ((*p) - 48);
		    if (st_mode < 0 || st_mode > 9)
			break;
		    if (st_mode > 7)
			st_mode = 0;
		    st_fg = ((*++p) - 48) + 30;
		    if (st_fg < 30 || st_fg > 39) {
			st_fg = 0;
			st_bg = 0;
			p--;
		    }
		    else {
			if (st_fg > 37)
			    st_fg = 0;
			st_bg = ((*++p) - 48) + 40;
			if (st_bg < 40 || st_bg > 47) {
			    st_bg = 0;
			    p--;
			}
		    }
		    sprintf(q, szin(st_fg, st_bg, st_mode));
		    szini = strlen(szin(st_fg, st_bg, st_mode)) - 1;
		    q += szini;
		    szinekben += szini + 1;
		    szini = 0;
		    break;
		case 'l':
		case 'L':
		    if (logfile) {
			strcpy(q, logfilename);
			q += strlen(logfilename) - 1;
		    }
		    else {
			strcpy(q, "<nincs log>");
			q += 10;
		    }
		    p++;
		    break;
		case 'W':
		case 'w':
		    strcpy(q, winbase);
		    q += strlen(winbase) - 1;
		    p++;
		    break;
		case 'n':
		case 'N':
		    strcpy(q, akii_nick->ertek);
		    q += strlen(akii_nick->ertek) - 1;
		    p++;
		    break;
		case 'E':
		case 'e':
		    ido = time(NULL) - starttime;
		    t = timeinterval(ido);
		    strcpy(q, t);
		    q += 5;
		    p++;
		    break;
		case 'T':
		case 't':
		    ido = time(NULL);
		    t = ctime(&ido);
		    strcpy(q, t + 11);
		    q += 4;
		    p++;
		    break;
		case '%':
		    *q = '%';
		    p++;
		    break;
		case '>':
		    if (statusz)
			*q = 2;
		    else
			*q = 32;
		    p++;
		    break;
		case '~':
		    if (statusz)
			*q = 1;
		    else
			*q = 32;
		    p++;
		    break;
		case 'i':
		case 'I':
		    *q = (insertmode) ? 'I' : 'O';
		    p++;
		    break;
	    }
	else
	    *q = *p;
	if (!p)
	    break;
	p++;
	q++;
    }
    *q = 0;
    t = parsedollar(ide);
    if (errno) {
	free(t);
	ide[0] = 0;
#ifdef AKII_DEBUG
	dbgleave(dbg_parsestatus);
#endif
	return;
    }
    strcpy(ide, t);
    free(t);
    if (!statusz) {
#ifdef AKII_DEBUG
	dbgleave(dbg_parsestatus);
#endif
	return;
    }
    b = strchr(ide, 1);
    if (b) {
/*                static char temp[200]; */
	*b = 0;
	k = strszlen(ide);
	*b = 32;
	i = strlen(b + 1);
	t = strchr(b + 1, 2);
	if (t)
	    *t = 0;
	if (t)
	    kk = strszlen(t + 1);
	else
	    kk = 0;
	ii = strszlen(b + 1);
	if (t)
	    *t = 2;
	l = strlen(ide);
	while ((COLS / 2) > (ii / 2 + k)) {
/*                        echostr(b+1); */
	    if (kk)
		if ((ii + 1) / 2 + kk > ((COLS - 1) / 2) - 1) {
		    t = strchr(b + 1, 2);
		    if (t)
			*t = 32;
		    *b = 2;
		    break;
		}
	    for (j = 0; j <= i; j++) {
/*                                printf("\0337\033[1;80H%d\0338",j); */
		ide[l - j + ((COLS - 1) / 2 - k - (ii / 2))] = ide[l - j];
	    }
	    for (i = (COLS - 1) / 2 - (ii / 2) - k + 1; i; i--) {
		*b++ = 32;
	    }
	    break;
	}
    }
    ide[COLS + szinekben - 1] = 0;
    b = strchr(ide, 2);
    if (b) {
	*b = 32;
	if ((i = strlen(ide)) < COLS + szinekben - 1) {
	    for (j = 1; j <= i - (b - ide); j++)
		ide[(COLS + szinekben - 1) - j] = ide[i - j];
	    for (i = (COLS + szinekben - 1) - i; i; i--) {
		*b++ = 32;
	    }
	}
    }
    for (i = strlen(ide); i <= COLS + szinekben - 1; i++)
	ide[i] = 32;
    ide[COLS + szinekben - 1] = 0;
#ifdef AKII_DEBUG
    dbgleave(dbg_parsestatus);
#endif
    return;
}
void writestatus(void)
{
    static char sline[300] = "";

    parsestatus(akii_status->ertek, sline, 1);
    if (strcmp(sline, lastsline) == 0) {
	return;
    }
    if (!botmode)
	printf("\033[%d;1H%s\033[0m\033[K\033[%d;%dH", LINES - 1, sline, LINES, (curcur > 0) ? curcur : 1);
    strcpy(lastsline, sline);
    return;
}
void getprevinp(void)
{
    curcur = -1;
    if (!ainp)
	ainp = inps;
    else
	ainp = ainp->prev;
    if (!savecursor) {
	strcpy(saveinp, inp);
	savecursor = cursor;
	strcpy(inp, ainp->s);
	cursor = strlen(inp) + 1;
	inplen = cursor - 1;
	return;
    }
    if (!ainp) {
	ainp = binp;
	return;
    }
    strcpy(inp, ainp->s);
    cursor = strlen(inp) + 1;
    inplen = cursor - 1;
    return;
}
void getnextinp(void)
{
    if (!ainp)
	return;
    if ((!ainp->next) && (!savecursor))
	return;
    curcur = -1;
    if ((savecursor) && (!ainp->next)) {
	cursor = savecursor;
	savecursor = 0;
	strcpy(inp, saveinp);
	inplen = strlen(inp);
	ainp = NULL;
	return;
    }
    ainp = ainp->next;
    strcpy(inp, ainp->s);
    cursor = strlen(inp) + 1;
    inplen = cursor - 1;
    return;
}
void putinp(void)
{
    struct inplines *p;

    if (!inpnum) {
	inpnum++;
	binp = inps = malloc(sizeof(struct inplines));

	inps->s = malloc(strlen(inp) + 1);
	strcpy(inps->s, inp);
	inps->prev = inps->next = NULL;
	ainp = NULL;
	return;
    }
    p = inps->next = malloc(sizeof(struct inplines));

    p->s = malloc(strlen(inp) + 1);
    strcpy(p->s, inp);
    p->prev = inps;
    p->next = NULL;
    inps = p;
    if (++inpnum > 100) {
	inpnum--;
	free(binp->s);
	p = binp;
	binp = binp->next;
	binp->prev = NULL;
	free(p);
    }
    ainp = NULL;
    return;
}
void strins(char *p, int l, char *ezt)
{
    int i, x, y;

    x = strlen(ezt) - 1;
    y = strlen(p);
    for (i = y; i >= l; i--) {
	p[i + x] = p[i];
    }
    p[i + x] = 0;
    x++;
    for (i = 0; i < x; i++)
	p[l + i] = ezt[i];
    return;
}
void writeinput(void)
{
    int i = 0, cur, l, x, f = 0, len;
    static char temp[1300];
    char *s;

    if (botmode)
	return;
    if (scrollsorok) {
	sprintf(temp, "%s ---=== GORGETES ===---", szin(37, 41, 1));
	memset(temp + 35, 32, 300);
	sprintf(temp + COLS + 11, "%s", szin(0, 0, 0));
	if (strcmp(temp, curinp)) {
	    printf("\033[%d;1H%s\033[K", LINES, temp);
	    strcpy(curinp, temp);
	}
	return;
    }
    parsestatus(akii_prompt->ertek, temp, 0);
    l = strszlen(temp);
    len = strlen(temp);
    if (l > COLS - 40) {
	f = 0;
	for (x = i = 0; temp[i]; i++) {
	    if (x > COLS - 40)
		break;
	    if (temp[i] == '\033') {
		f ^= 1;
		continue;
	    }
	    if (f && (temp[i] == 'm')) {
		f ^= 1;
		continue;
	    }
	    if (!f)
		x++;
	}
	temp[i] = 0;
	if (i != x)
	    strcat(temp, "\033[0m");
    }
    l = strszlen(temp);
    len = strlen(temp);
    while (cursor - gorg + l >= COLS - 1)
	gorg += 30;
    while ((cursor <= gorg + 3) && (gorg))
	gorg -= 30;
    strcat(temp, inp + gorg);
    if (strszlen(temp) >= COLS - 1) {
	f = 0;
	for (x = i = 0; temp[i]; i++) {
	    if (x > COLS - 3)
		break;
	    if (temp[i] == '\033') {
		f ^= 1;
		continue;
	    }
	    if (f && (temp[i] == 'm')) {
		f ^= 1;
		continue;
	    }
	    if (!f)
		x++;
	}
	temp[i] = 0;
#ifdef __CYGWIN32__
	strcat(temp, "\033[1;33;44m>\033[0m");
#else
	strcat(temp, "\033[33;44;1m>\033[0m");
#endif
    }
    if (gorg) {
#ifdef __CYGWIN32__
	strins(temp + len, 0, "\033[1;33;44m<\033[0m");
#else
	strins(temp + len, 0, "\033[33;44;1m<\033[0m");
#endif
    }
    if (strcmp(temp, curinp)) {
	for (x = i = 0; 1; i++) {
	    if (temp[i] == 033) {
		f = 1;
	    }
	    if (!f)
		x++;
	    if ((f) && (temp[i] == 'm'))
		f = 0;
	    if (temp[i] != curinp[i]) {
		if (temp[i] == 033)
		    x++;
		break;
	    }
	    if ((!temp[i]) || (!curinp[i]))
		break;
	}
	printf("\033[%d;%dH\033[K%s", LINES, x, temp + i);
	strcpy(curinp, temp);
    }
    cur = l + cursor - gorg;
    if (curcur != cur) {
	printf("\033[%d;%dH", LINES, cur);
	curcur = cur;
    }
    return;
}
void sigwinch(int signo)
{
    getwinsize();
    if (LINES < 8 || COLS < 30) {
	botmode = 100;
    }
    else if (botmode == 100)
	botmode = 0;
    if (signo) {
	setivar(akii_termwidth, COLS);
	setivar(akii_termheight, LINES);
    }
    if (winsize > LINES - 5) {
	winsize = LINES - 5;
	oldwinsize = winsize;
	resizewindow(signo);
    }
    else if (winsize && wantedwinsize > winsize && wantedwinsize <= LINES - 5) {
	winsize = wantedwinsize;
	oldwinsize = winsize;
	resizewindow(signo);
    }
    if (!winsize) {
	if (oldwinsize > LINES - 5)
	    oldwinsize = LINES - 5;
	else if (wantedwinsize <= LINES - 5)
	    oldwinsize = wantedwinsize;
    }
    if (signo)
	refresh(1);
    if (botmode == 100)
	printf("\033[2J\033[r\033[1mEz az ablak\nmar kicsi\naz akII szamara!\n");
    signal(SIGWINCH, sigwinch);
    return;
}
void resizewindow(int notinit)
{
    int i;

    if (notinit)
	setivar(akii_winsize, winsize);
    if (topline) {
	i = (topline - 1) % winsize;
	topline -= i;
	if (topline <= 0)
	    topline = 1;
    }
    return;
}
void writewindow(void)
{
    int i;

    if (!winsize)
	return;
    if (botmode)
	return;
    if (!nocs)
	printf("\033[?25l");
    printf("\033[1;1H");
    for (i = 0; i < winsize; i++) {
	if (i + topline >= 2000)
	    printf("\033[K\n");
	else
	    printf("%s\033[K\033[0m\n", (winlines[i + topline]) ? chop(winlines[i + topline]) : "");
    }
    printf("\033[%d;%dH", LINES, curcur);
    if (!nocs)
	printf("\033[?25h");
    return;
}
void writewindowstatus(void)
{
    static char sline[300] = "";

    if (!winsize)
	return;
    if (botmode)
	return;
    parsestatus(akii_winstatus->ertek, sline, 1);
    if (strcmp(sline, lastwinsline) == 0) {
	return;
    }
    if (!botmode)
	printf("\033[%d;1H%s\033[0m\033[K\033[%d;%dH", winsize + 1, sline, LINES, (curcur > 0) ? (curcur) : 1);
    strcpy(lastwinsline, sline);
    return;
}
void winfress(int i, char *s)
{
    if (botmode)
	return;
    if (winlines[i])
	free(winlines[i]);
    winlines[i] = strdup(s);;
    if (lastwinline < i)
	lastwinline = i;
    if (!winsize)
	return;
    if (i < topline)
	return;
    if (i >= topline + winsize)
	return;
    printf("\033[%d;1H%s\033[0m\033[K\033[%d;%dH", i - topline + 1, chop(winlines[i]), LINES, curcur);
    return;
}
